import c4d
from c4d import gui
from c4d import storage,bitmaps
from c4d.modules import bodypaint

# Welcome to the world of Python


# Script state in the menu or the command palette
# Return True or c4d.CMD_ENABLED to enable, False or 0 to disable
# Alternatively return c4d.CMD_ENABLED|c4d.CMD_VALUE to enable and check/mark
#def state():
#    return True

# Main function
def main():


    #mat=doc.GetActiveMaterial()
    mat=c4d.Material()
    mat.SetChannelState(c4d.CHANNEL_COLOR,True)
    mat.SetChannelState(c4d.CHANNEL_ALPHA,True)


    shader=c4d.BaseShader(c4d.Xprojector)

    mat[c4d.MATERIAL_COLOR_SHADER]=shader
    mat.InsertShader(shader)
    shader[c4d.SLA_PROJECTOR_PROJECTION]=c4d.SLA_PROJECTOR_PROJECTION_UVW


    patho=c4d.GetGlobalTexturePath(0)
    img=storage.LoadDialog(c4d.FILESELECTTYPE_IMAGES,flags=c4d.FILESELECT_LOAD,title="Image",force_suffix="C:/",def_path=patho,def_file="")
    bitmap=c4d.bitmaps.BaseBitmap()
    bitmap.InitWith(img, frame=-1)
    #x, y = bitmap.GetSize()

    imgshade=c4d.BaseList2D(c4d.Xbitmap)
    shader[c4d.SLA_PROJECTOR_TEXTURE]=imgshade
    imgshade[c4d.BITMAPSHADER_FILENAME]=img

    mat.InsertShader(imgshade)
    doc.InsertMaterial(mat,checknames=True)
    #c4d.modules.bodypaint.PaintMaterial.EnableMaterial(doc)
    c4d.CallCommand(17015)

    #imgname=img.split("\\")[-1].split(".")[0]+"_mask"
    texture_name=mat[c4d.ID_BASELIST_NAME]+"_mask.jpg"
    bc=c4d.BaseContainer()
    bc[c4d.TEXTURE_FILEFORMAT]=c4d.FILTER_JPG
    bc[c4d.TEXTURE_WIDTH]=512
    bc[c4d.TEXTURE_HEIGHT]=512
    bc[c4d.TEXTURE_MODE]=c4d.COLORMODE_GRAY
    bc[c4d.TEXTURE_SAVE_IMMEDIATLY]=False

    texture=bodypaint.PaintTexture.CreateNewTexture(texture_name,bc)

    alpha_shader=c4d.BaseList2D(c4d.Xbitmap)




    #=============Material anlegen==========================================

    mat.SetChannelState(c4d.CHANNEL_REFLECTION, False)

    mat[c4d.MATERIAL_ALPHA_SHADER]=alpha_shader
    #mat[c4d.MATERIAL_ALPHA_SHADER]=imgshade_alpha
    alpha_shader[c4d.BITMAPSHADER_FILENAME]=texture_name
    mat.InsertShader(alpha_shader)
    doc.SetActiveMaterial(mat)

    tag=c4d.BaseTag(c4d.Ttexture)
    tag[c4d.TEXTURETAG_PROJECTION]=6
    last=doc.GetActiveObject().GetTags()[-1]
    doc.GetActiveObject().InsertTag(tag, pred=last)
    tag[c4d.TEXTURETAG_MATERIAL]=mat
    #c4d.CallCommand(17258)




    c4d.EventAdd()



# Execute main()
if __name__=='__main__':
    main()